/*                               -*- Mode: C -*- 
 * f-util.c --- 
 * Author          : Nicolas Anquetil
 * Created On      : Tue Oct 15 12:03:03 1996
 * Last Modified By: Nicolas Anquetil
 * Last Modified On: Wed Feb  4 12:39:16 1998
 */


# include "f-util.h"


char *outfilename(char *filename)
/**************************************************
 * only used by pyy, add `pre-' at the beginning of a file name
 */
{
  char *fout;

  fout = (char *)malloc( strlen(filename) + 5);
  sprintf( fout, "pre-%s", filename);

  return( fout);
}


char *basename( char *fname)
/**************************************************
 * return the base name of a file, i.e. whitout possible leading path
 */
{
  char *base, *s;

  base = malloc( strlen(fname)+1 );    /* max length for the basename */
  for (s=base; *fname; fname++)
	if (*fname == '/')
	  s=base;                  /* here we don't want to ++ `s' */
	else
	  *s++ = *fname;

  *s = '\0';

  return(base);
}


char *pathname( char *fname)
/**************************************************
 * returns the (absolute) path of a file
 */
{
  char *path, *s, *fn, t[100];
  FILE *pipe;

  if (fname == NULL)
	path = NULL;

  else {
	fn=malloc( strlen(fname) + 1);
	strcpy( fn, fname);

	for ( s=fn+strlen(fname); (*s != '/') && (s != fn); s--) ;

	if (*s == '/') {
	  s++;
	  *s = '\0';    /* suppress the file's base name from `fn',
					   leaving only its path (relative to working dir) */
	  sprintf(t,"cd %s ; pwd\n", fn);
	}
	else
	  strcpy(t,"pwd\n");

	/* if fname is an absolute path, we got our path */
	if (*fn == '/') {
	  path = malloc(strlen(fn)+1);
	  strcpy(path, fn);
	}
	else /* otherwise, call the system to find out */
	  if ( (pipe=popen( t, "r")) == NULL)
		path = NULL;
	  else {
		fscanf(pipe, "%s", t);
		pclose(pipe);
		path = malloc(strlen(t)+1);
		strcpy(path, t);
	  }

	free(fn);
  }  /* if (fname == NULL) ... else */

  return(path);
}


int fsize(FILE *f)
/**************************************************
 */
{
  int sz, pos;

  pos = ftell(f);   /* save current position */

  fseek( f, 0, SEEK_END); /* go to end of file */
  sz = ftell(f);      /* get the eof pos = size */

  fseek( f, pos, SEEK_SET); /* go back to initial pos */

  return(sz);
}


int set_infile(char *fname)
/**************************************************
 */
{
  int retn;

  retn = 1;

  if (yyin)
	fclose( yyin);

  if (fname) {
	free( sourcefilename);
	sourcefilename = basename( fname);
	yyin = fopen(fname, "r");
	if (! yyin) {
	  fprintf(stderr,"Could not open input file `%s'\n", sourcefilename);
	  retn = 0;
	}
  }
  else 
	yyin = stdin;

  return( retn);
}


int set_outfile(char *fname)
/**************************************************
 * mainly for pyy (I think)
 */
{
  int retn;

  retn = 1;

  if (yyout)
	fclose( yyout);

  if (fname) {
	yyout = fopen(fname, "w");
	if (! yyout) {
	  fprintf(stderr,"Could not open output file: `%s'\n", fname);
	  retn = 0;
	}
  }
  else
	yyout = stdout;

  return( retn);
}

/**************************************************
 * Local Variables: 
 * tab-width: 4
 * End:
 */
