/*                               -*- Mode: C -*- 
 * fifo-list.c --- This program contains utility functions to manipulate 
 *                 single-linked (fifo) lists
 * Author          : Javed Chowdhury.
 * Created On      : 
 */
 
# include "fifo-list.h"

list *initList()
/******************************************************
 *   initialize to NULL 
 */
{
  list *l;
  
  l = NEW(list);
  l->first =  NULL;
  l->last = NULL;


  return(l);
}


listElt *initListElt()
/**************************************************
 */
{
  listElt *new;
  
  new = NEW(listElt);
  new->item = NULL;
  new->next = NULL;

  return (new);
}


FIFO_ELT_TYPE addElement(list *l, FIFO_ELT_TYPE element)
/******************************************************
 *   It will add an element on top of the list
 */
{
  listElt *newOne;

  newOne = initListElt();
  newOne->item = element;
  if (emptyList(l) == FALSE) {
    l->last->next = newOne;
    l->last = newOne;
  }
  else
    l->first = l->last = newOne;
  
  return(element);
}

FIFO_ELT_TYPE delElement(list *l)
/**************************************************
 */
{
  listElt *old;
  FIFO_ELT_TYPE element;

  if ( emptyList(l) == TRUE) {
	fprintf(stderr,"** Empty list, can't delete top element\n");
	exit(2);
  }
  else {
	element = l->first->item;
	old = l->first->next;
	free (l->first);
	l->first = old;
     
	if (l->first == NULL)
	  l->last = NULL;
  }

  return(element);
}


FIFO_ELT_TYPE topElement(list *l)
/*******************************************************
 */
{
  if ( emptyList(l) == TRUE ) {
	fprintf(stderr,"** Empty list, can't return top element\n");
	exit(2);
  }
  else
	return(l->first->item);
}


bool emptyList(list *l)
/**************************************************
*/
{ 
  if (l->first == NULL)
    return(TRUE);
  else 
    return(FALSE);
}

