/*                               -*- Mode: C -*- 
 * fifo-list.h --- Declaration of list element structure, 
 *                 external definition and function used in fifo-list.c
 * Author          : Javed Chowdhury
 * Created On      : 
 */

# ifndef FIFO_LIST_H
# define FIFO_LIST_H

# include <stdio.h>
# include "c++_c.h"

# ifndef FIFO_ELT_TYPE
# define FIFO_ELT_TYPE void*
# endif


/* data structure for list */ 
typedef struct list_element {
  FIFO_ELT_TYPE item;
  struct list_element *next;
} listElt;

/* type define first and last elt for list */
typedef struct list_t {
  listElt *first,
          *last;
} list;


FIFO_ELT_TYPE addElement(list *l, FIFO_ELT_TYPE element);
FIFO_ELT_TYPE delElement(list *l);
FIFO_ELT_TYPE topElement(list *l);
list *initList();
bool  emptyList(list *l);

# endif
